Unit IAC2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IAC1R1_p, IAC1R2_p, IAC1R3_p, IAC1R4_p;

procedure IAC2R(var X :Array of Real; NX :Integer;
                var Y :Array of Real; NY :Integer;
                var FXY :Array of Real; NFX :Integer; NFY :Integer;
                LX :Integer; LY :Integer; MXA :Integer;
                var FXA :Array of Real; MXB :Integer;
                var FXB :Array of Real; MYA :Integer;
                var FYA :Array of Real; MYB :Integer;
                var FYB :Array of Real; var TX :Array of Real;
                var TY :Array of Real; var CXY :Array of Real;
                NCX :Integer; NCY :Integer; var CY :Array of Real);

implementation

procedure IAC2R(var X :Array of Real; NX :Integer;
                var Y :Array of Real; NY :Integer;
                var FXY :Array of Real; NFX :Integer; NFY :Integer;
                LX :Integer; LY :Integer; MXA :Integer;
                var FXA :Array of Real; MXB :Integer;
                var FXB :Array of Real; MYA :Integer;
                var FYA :Array of Real; MYB :Integer;
                var FYB :Array of Real; var TX :Array of Real;
                var TY :Array of Real; var CXY :Array of Real;
                NCX :Integer; NCY :Integer; var CY :Array of Real);
var
I,J,K,L,M,N :Integer;
FA,FB :Real;
A :Array [0..2] of Real;
B :Array [0..2] of Real;
const
K0 :Integer = 0;
K1 :Integer = 1;
K2 :Integer = 2;
K3 :Integer = 3;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210;
begin
IAC1R2(X,NX,MXA,TX);
IAC1R2(Y,NY,MYA,TY);
for I:=K1 to NX do
 begin
  J  := K2 + I;
  for K:=K1 to NY do
   begin
    L  := K2 + K;
    CXY[(J-1)+(L-1)*NCX] := FXY[(I-1)+(K-1)*NFX];
_10:
   end;
_20:
 end;
M  := NX + K2;
N  := NY + K2;
if ( MXA  >  K2 ) 
 then goto _50;
IAC1R3(TX,NX,CY,LX,MXA,MXB,A,B);
for I:=K3 to N do
 begin
  J  := I - K2;
  if ( MXA  >=  K1 )
   then FA  := FXA[J-1];
  if ( MXB  >=  K1 ) 
   then FB  := FXB[J-1];
  for J:=K3 to M do
   begin
    CY[J-1] := CXY[(J-1)+(I-1)*NCX];
_30:
   end;
  IAC1R4(TX,NX,CY,LX,MXA,FA,MXB,FB,A,B);
  CXY[(K1-1)+(I-1)*NCX] := CY[K1-1];
  CXY[(K2-1)+(I-1)*NCX] := CY[K2-1];
  K  := M + K1;
  CXY[(K-1)+(I-1)*NCX] := CY[K-1];
  K  := K + K1;
  CXY[(K-1)+(I-1)*NCX] := CY[K-1];
_40:
 end;
_50:
if ( MYA  >  K2 ) 
 then goto _110;
IAC1R3(TY,NY,CY,LY,MYA,MYB,A,B);
for I:=K3 to M do
 begin
  J  := I - K2;
  if ( MYA  >=  K1 ) 
   then FA  := FYA[J-1];
  if ( MYB  >=  K1 ) 
   then FB  := FYB[J-1];
  for J:=K3 to N do
   begin
    CY[J-1] := CXY[(I-1)+(J-1)*NCX];
_60:
   end;
  IAC1R4(TY,NY,CY,LY,MYA,FA,MYB,FB,A,B);
  CXY[(I-1)+(K1-1)*NCX] := CY[K1-1];
  CXY[(I-1)+(K2-1)*NCX] := CY[K2-1];
  K  := N + K1;
  CXY[(I-1)+(K-1)*NCX] := CY[K-1];
  K  := K + K1;
  CXY[(I-1)+(K-1)*NCX] := CY[K-1];
_70:
 end;
if ( MXA  >  K2 ) 
 then goto _130;
IAC1R3(TY,NY,CY,LY,K0,K0,A,B);
for I:=K1 to K2 do
 begin
  K  := K3 - I;
  for J:=K3 to N do
   begin
    CY[J-1] := CXY[(K-1)+(J-1)*NCX];
_80:
   end;
  IAC1R4(TY,NY,CY,LY,K0,FA,K0,FB,A,B);
  CXY[(K-1)+(K1-1)*NCX] := CY[K1-1];
  CXY[(K-1)+(K2-1)*NCX] := CY[K2-1];
  L  := N + K1;
  CXY[(K-1)+(L-1)*NCX] := CY[L-1];
  L  := L + K1;
  CXY[(K-1)+(L-1)*NCX] := CY[L-1];
  K  := M + I;
  for J:=K3 to N do
   begin
    CY[J-1] := CXY[(K-1)+(J-1)*NCX];
_90:
   end;
  IAC1R4(TY,NY,CY,LY,K0,FA,K0,FB,A,B);
  CXY[(K-1)+(K1-1)*NCX] := CY[K1-1];
  CXY[(K-1)+(K2-1)*NCX] := CY[K2-1];
  L  := N + K1;
  CXY[(K-1)+(L-1)*NCX] := CY[L-1];
  L  := L + K1;
  CXY[(K-1)+(L-1)*NCX] := CY[L-1];
_100:
 end;
M  := M + K2;
N  := N + K2;
goto _150;
_110:
K  := K3;
if ( MXA  <  K3 ) 
 then K  := K - K2;
if ( MXA  <  K3 ) 
 then M  := M + K2;
for I:=K to M do
 begin
  J  := N - K1;
  CXY[(I-1)+(K1-1)*NCX] := CXY[(I-1)+(J-1)*NCX];
  J  := J - K1;
  CXY[(I-1)+(K2-1)*NCX] := CXY[(I-1)+(J-1)*NCX];
  J  := K3 + K1;
  L  := N + K1;
  CXY[(I-1)+(L-1)*NCX] := CXY[(I-1)+(J-1)*NCX];
  J  := J + K1;
  L  := L + K1;
  CXY[(I-1)+(L-1)*NCX] := CXY[(I-1)+(J-1)*NCX];
_120:
 end;
_130:
N  := N + K2;
if ( MXA  >  K2 ) 
 then goto _150;
for I:=K1 to N do
 begin
  J  := M - K1;
  CXY[(K1-1)+(I-1)*NCX] := CXY[(J-1)+(I-1)*NCX];
  J  := J - K1;
  CXY[(K2-1)+(I-1)*NCX] := CXY[(J-1)+(I-1)*NCX];
  L  := K3 + K1;
  J  := M + K1;
  CXY[(J-1)+(I-1)*NCX] := CXY[(L-1)+(I-1)*NCX];
  L  := L + K1;
  J  := J + K1;
  CXY[(J-1)+(I-1)*NCX] := CXY[(L-1)+(I-1)*NCX];
_140:
 end;
M  := M + K2;
_150:
L  := N - K2;
for I:=K1 to M do
 begin
  for J:=K1 to N do
   begin
    CY[J-1] := CXY[(I-1)+(J-1)*NCX];
_160:
   end;
  for J:=K1 to L do
   begin
    K  := K1 + J;
    CXY[(I-1)+(J-1)*NCX] := IAC1R1(TY,CY,LY,K);
_170:
   end;
_180:
 end;
N  := M - K2;
for I:=K1 to L do
 begin
  for J:=K1 to M do
   begin
    CY[J-1] := CXY[(J-1)+(I-1)*NCX];
_190:
   end;
  for J:=K1 to N do
   begin
    K  := K1 + J;
    CXY[(J-1)+(I-1)*NCX] := IAC1R1(TX,CY,LX,K);
_200:
   end;
_210:
 end;
end;

end.
